//
//  OrderedFoodsCollectionHeaderView.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 06/02/19.
//  Copyright © 2019 admin. All rights reserved.

import Foundation

class OrderedFoodsCollectionHeaderView: UICollectionReusableView
{
    var headerTitle : String!
    
    override init(frame: CGRect)
    {
        super.init(frame: frame)
        self.translatesAutoresizingMaskIntoConstraints = false
    }
    
    lazy var titleLabel : UILabel =
        {
           
            let titleLabel = UILabel()
            titleLabel.translatesAutoresizingMaskIntoConstraints = false
            self.addSubview(titleLabel)
            
            titleLabel.font = UIFont.systemFont(ofSize: 18, weight: UIFont.Weight.semibold)
            titleLabel.textColor = UIColor.init(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 1/1.0)
            
       
            self.addConstraint(NSLayoutConstraint(item: titleLabel, attribute: .height, relatedBy: .equal, toItem: self, attribute: .height, multiplier: 1.0, constant: 0))
            self.addConstraint(NSLayoutConstraint(item: titleLabel, attribute: .left, relatedBy: .equal, toItem: self, attribute: .left, multiplier: 1.0, constant: 15))
            self.addConstraint(NSLayoutConstraint(item: titleLabel, attribute: .right, relatedBy: .equal, toItem: self, attribute: .right, multiplier: 1.0, constant: 0))
            self.addConstraint(NSLayoutConstraint(item: titleLabel, attribute: .bottom, relatedBy: .equal, toItem: self, attribute: .bottom, multiplier: 1.0, constant: 0))
            self.addConstraint(NSLayoutConstraint(item: titleLabel, attribute: .top, relatedBy: .equal, toItem: self, attribute: .top, multiplier: 1.0, constant: 5))
            
            return titleLabel
    }()
    
    func configureHeader(title: String)
    {
        titleLabel.text = title
    }
    
    required init?(coder aDecoder: NSCoder)
    {
        fatalError("init(coder:) has not been implemented")
    }
    
}
