//
//  ComplainServicesLister.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 09/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation
import ZCCoreFramework

class ComplainServicesLister: UIViewController {
    
    var choiceList:[Choice] = []
    var barTitle : String = "Select Choice"
    var selectedChoice: Choice?
    
    weak var parentView: ShuttleView?
    var serviceSelector: SingleSelectedChoice?
    
    static var complainServicesReuseIds : String {
        return String(describing: self)
    }
    
    var choiceListTableView = UITableView ()
    var loader = UIActivityIndicatorView()
    
    override func viewWillAppear(_ animated: Bool) {
        self.navigationController?.setNavigationBarHidden(false, animated: false)
    }
    override func viewWillDisappear(_ animated: Bool) {
        self.navigationController?.setNavigationBarHidden(true, animated: false)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view?.backgroundColor = UIColor.brown
        
        self.view.addSubview(choiceListTableView)
        choiceListTableView.translatesAutoresizingMaskIntoConstraints = false
        choiceListTableView.delegate = self
        choiceListTableView.dataSource = self
        choiceListTableView.register(UITableViewCell.self, forCellReuseIdentifier: ComplainServicesLister.complainServicesReuseIds)
        choiceListTableView.separatorStyle = .singleLine
        choiceListTableView.tableFooterView = UIView.init(frame: CGRect(x: 0, y: 0, width: 1, height: 1))
        
        choiceListTableView.leftAnchor.constraint(equalTo: self.view.leftAnchor, constant: 0).isActive = true
        choiceListTableView.topAnchor.constraint(equalTo: self.view.topAnchor, constant: 0).isActive = true
        choiceListTableView.rightAnchor.constraint(equalTo: self.view.rightAnchor, constant: 0).isActive = true
        choiceListTableView.bottomAnchor.constraint(equalTo: self.view.bottomAnchor, constant: 0).isActive = true
        choiceListTableView.reloadData()
        
        self.navigationItem.title = barTitle
        self.navigationItem.backBarButtonItem = UIBarButtonItem(title: "back", style: .plain, target: nil, action: nil)
    }
}


extension ComplainServicesLister: UITableViewDataSource {
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return UITableView.automaticDimension
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return choiceList.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: ComplainServicesLister.complainServicesReuseIds, for: indexPath) as UITableViewCell
        let choice = choiceList[indexPath.row]
        if(choice.key == selectedChoice?.key) {
            cell.accessoryType = UITableViewCell.AccessoryType.checkmark
        }
        cell.textLabel?.text = choice.key
        
        
        return cell
    }
}


extension ComplainServicesLister: UITableViewDelegate {
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let selectedChoice = choiceList[indexPath.row]
        
        if let delegate = serviceSelector {
            delegate.addchoiceinSingleSelectField(selectedChoice: selectedChoice)
        }
        self.navigationController?.popViewController(animated: true)
    }
}
