//
//  ComplainSuccessfullyRaisedView.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 09/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation

class ComplainSuccessfullyRaisedView: UIView {
    
    lazy var complainIconImageView : UIImageView =
        {
            let imageView = UIImageView()
            imageView.image = UIImage.init(named: "complainLarge") ?? nil
            imageView.translatesAutoresizingMaskIntoConstraints = false
            addSubview(imageView)
            return imageView
    }()
    
    lazy var complainRaisedMessage : UILabel =
        {
            let titleLable = UILabel()
            titleLable.translatesAutoresizingMaskIntoConstraints = false
            titleLable.textAlignment = .center
            titleLable.text = "Our service superviser will contact you shortly"
            addSubview(titleLable)
            
            titleLable.font = UIFont.systemFont(ofSize: 16, weight: UIFont.Weight.semibold)
            titleLable.textColor  = UIColor.init(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 1/1.0)
            
            return titleLable
    }()
    
    weak var formViewControllerDelegate: FormViewController?
    
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        configureView()
    }
    
    func configureView() {
        
        let cabIconVerticalPadding : CGFloat =  -50
        NSLayoutConstraint.activate([
            complainIconImageView.centerXAnchor.constraint(equalTo: centerXAnchor),
            complainIconImageView.centerYAnchor.constraint(equalTo: centerYAnchor,constant: cabIconVerticalPadding)
            ])

        let titleLableHeight : CGFloat = 22

        NSLayoutConstraint.activate([complainRaisedMessage.leftAnchor.constraint(equalTo: self.leftAnchor),complainRaisedMessage.rightAnchor.constraint(equalTo: self.rightAnchor),complainRaisedMessage.topAnchor.constraint(equalTo: complainIconImageView.bottomAnchor, constant: 30),complainRaisedMessage.heightAnchor.constraint(equalToConstant: titleLableHeight)])
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}

