//
//  complaintsCellTableViewCell.swift
//  Complaints
//
//  Created by ZOHO corporation  on 07/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import UIKit

class ComplaintEntryCell: UITableViewCell{
    
    weak var delegate:ComplaintsViewController?
    
    lazy var leftView : UIView = {
        var leftView = UIView()
        leftView.backgroundColor = UIColor(red: 249/255, green: 249/255, blue: 249/255, alpha: 1)
        leftView.translatesAutoresizingMaskIntoConstraints = false
        return leftView
    }()
    
    lazy var separator :UIView = {
        var separator = UIView ()
        separator.translatesAutoresizingMaskIntoConstraints = false
        separator.backgroundColor = UIColor(red: 240/255, green: 240/255, blue: 240/255, alpha: 1)
        return separator
    }()
    
    lazy var rightView : UIView = {
        var rightView = UIView()
        rightView.backgroundColor = UIColor.white
        rightView.translatesAutoresizingMaskIntoConstraints = false
        return rightView
    }()
    
    lazy var nameLabel : UILabel = {
        
        var nameLabel = UILabel()
        nameLabel.text = "Enter Compaints"
        nameLabel.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        nameLabel.numberOfLines = 0
        nameLabel.translatesAutoresizingMaskIntoConstraints = false
        return nameLabel
        
    }()
    
    lazy var entryTextView : UITextView = {
        var entryTextView = UITextView()
        entryTextView.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        entryTextView.isScrollEnabled = false
        entryTextView.delegate = self
        entryTextView.translatesAutoresizingMaskIntoConstraints = false
        return entryTextView
    }()
    
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        
        self.contentView.addSubview(leftView)
        
        let leftViewWidth:CGFloat = 145
        
        NSLayoutConstraint(item: leftView, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .width, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: leftViewWidth).isActive = true
        
        self.contentView.addSubview(rightView)
        
        NSLayoutConstraint(item: rightView, attribute: .leading, relatedBy: .equal, toItem: leftView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        
        leftView.addSubview(nameLabel)
        
        let nameLabelLeftPadding:CGFloat = 15
        let nameLabelrightPadding:CGFloat = 15
        let nameLabeltopPadding:CGFloat = 15
        let nameLabelbottomPadding:CGFloat = 15
        
        
        NSLayoutConstraint(item: nameLabel, attribute: .leading, relatedBy: .equal, toItem: self.leftView, attribute: .leading, multiplier: 1, constant: nameLabelLeftPadding).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .top, relatedBy: .equal, toItem: self.leftView, attribute: .top, multiplier: 1, constant: nameLabeltopPadding).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .bottom, relatedBy: .lessThanOrEqual, toItem: self.leftView, attribute: .bottom, multiplier: 1, constant: -nameLabelbottomPadding).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .trailing, relatedBy: .equal, toItem: self.leftView, attribute: .trailing, multiplier: 1, constant: -nameLabelrightPadding).isActive = true
        
        
        rightView.addSubview(entryTextView)
        
        let entryTextViewLeftPadding:CGFloat = 15
        let entryTextViewrightPadding:CGFloat = 15
        let entryTextViewltopPadding:CGFloat = 15
        let entryTextViewbottomPadding:CGFloat = 15
        
        NSLayoutConstraint(item: entryTextView, attribute: .leading, relatedBy: .equal, toItem: self.rightView, attribute: .leading, multiplier: 1, constant: entryTextViewLeftPadding).isActive = true
        NSLayoutConstraint(item: entryTextView, attribute: .top, relatedBy: .equal, toItem: self.rightView, attribute: .top, multiplier: 1, constant: entryTextViewltopPadding).isActive = true
        NSLayoutConstraint(item: entryTextView, attribute: .bottom, relatedBy: .lessThanOrEqual, toItem: self.rightView, attribute: .bottom, multiplier: 1, constant: -entryTextViewbottomPadding).isActive = true
        NSLayoutConstraint(item: entryTextView, attribute: .trailing, relatedBy: .equal, toItem: self.rightView, attribute: .trailing, multiplier: 1, constant: -entryTextViewrightPadding).isActive = true
        
        self.contentView.addSubview(separator)
        NSLayoutConstraint(item: separator, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: 0.5).isActive = true
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}


extension ComplaintEntryCell:UITextViewDelegate {
    
    func textViewDidChange(_ textView: UITextView) {
        delegate?.tableView.beginUpdates()
        delegate?.tableView.endUpdates()
    }
    
    func textViewDidEndEditing(_ textView: UITextView) {
        if entryTextView.text != ""{
            if let delegate = delegate {
                delegate.multiLine(text: entryTextView.text)
                
            }
        }else{
            if let delegate = delegate {
                delegate.multiLine(text: "")
                
            }
        }
        
    }
    
}




class SubmitButtoncell:UITableViewCell{
    lazy var submit : UIButton = {
        var submit = UIButton()
        submit.translatesAutoresizingMaskIntoConstraints = false
        submit.setTitle("Raise Complaint", for: .normal)
        submit.setTitleColor(UIColor(red: 0 / 255.0, green: 118 / 255.0, blue: 255 / 255.0, alpha: 1), for: .normal)
        submit.titleLabel?.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        return submit
    }()
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        
        self.contentView.addSubview(submit)
    
        NSLayoutConstraint(item: submit, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: submit, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: submit, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: submit, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: submit, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: 50).isActive = true
        
        let submitButton = submit
        let submitButtonTopBorderView = UIView()
        submitButtonTopBorderView.translatesAutoresizingMaskIntoConstraints = false
        submitButton.addSubview(submitButtonTopBorderView)
        submitButtonTopBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        let selectDropLocationBorderViewHeight : CGFloat = 1
        
        NSLayoutConstraint.activate([submitButtonTopBorderView.leftAnchor.constraint(equalTo: submitButton.leftAnchor),submitButtonTopBorderView.rightAnchor.constraint(equalTo: submitButton.rightAnchor),submitButtonTopBorderView.topAnchor.constraint(equalTo: submitButton.topAnchor),submitButtonTopBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
        
        let submitButtonBottomBorderView = UIView()
        submitButtonBottomBorderView.translatesAutoresizingMaskIntoConstraints = false
        submitButton.addSubview(submitButtonBottomBorderView)
        submitButtonBottomBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        
        NSLayoutConstraint.activate([submitButtonBottomBorderView.leftAnchor.constraint(equalTo: submitButton.leftAnchor),submitButtonBottomBorderView.rightAnchor.constraint(equalTo: submitButton.rightAnchor),submitButtonBottomBorderView.bottomAnchor.constraint(equalTo: submitButton.bottomAnchor),submitButtonBottomBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}

