//
//  ReportCell.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 10/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation

class ReportCell : UITableViewCell{
    
    weak var delegate:ComplaintsViewController?
    
    lazy var nameLabel : UILabel = {
        
        var nameLabel = UILabel()
        nameLabel.text = "Report Anonymously"
        nameLabel.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        nameLabel.numberOfLines = 0
        nameLabel.translatesAutoresizingMaskIntoConstraints = false
        return nameLabel
    }()
    
    lazy var separator :UIView = {
        var separator = UIView ()
        separator.translatesAutoresizingMaskIntoConstraints = false
        separator.backgroundColor = UIColor(red: 240/255, green: 240/255, blue: 240/255, alpha: 1)
        return separator
    }()
    
    lazy var switchView : UISwitch = {
        var switchView = UISwitch()
        switchView.translatesAutoresizingMaskIntoConstraints = false
        switchView.isOn = true
        return switchView
    }()
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        
        self.contentView.addSubview(nameLabel)
        self.contentView.addSubview(switchView)
        
        
        NSLayoutConstraint(item: nameLabel, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 15).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 21).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: -22).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .trailing, relatedBy: .equal, toItem: switchView, attribute: .leading, multiplier: 1, constant: -10).isActive = true
        
        NSLayoutConstraint(item: switchView, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 16.5).isActive = true
        NSLayoutConstraint(item: switchView, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: -16.5).isActive = true
        NSLayoutConstraint(item: switchView, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: -15).isActive = true
        
        self.contentView.addSubview(separator)
        NSLayoutConstraint(item: separator, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: 0.5).isActive = true
        
        switchView.addTarget(self, action: #selector(sendValue), for: .valueChanged)
    }
    
    
    @objc func sendValue(){
        if let delegate = delegate {
            delegate.switchValue(self.switchView.isOn, self.switchView.tag)
        }
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}
