//
//  ServiceCell.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 10/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation

class ServiceCell: UITableViewCell {
    
    weak var delegate:ComplaintsViewController?
    
    lazy var leftView : UIView = {
        var leftView = UIView()
        leftView.backgroundColor = UIColor(red: 249/255, green: 249/255, blue: 249/255, alpha: 1)
        leftView.translatesAutoresizingMaskIntoConstraints = false
        return leftView
    }()
    
    lazy var separator :UIView = {
        var separator = UIView ()
        separator.translatesAutoresizingMaskIntoConstraints = false
        separator.backgroundColor = UIColor(red: 240/255, green: 240/255, blue: 240/255, alpha: 1)
        return separator
    }()
    
    lazy var rightView : UIView = {
        var rightView = UIView()
        rightView.backgroundColor = UIColor.white
        rightView.translatesAutoresizingMaskIntoConstraints = false
        return rightView
    }()
    
    lazy var rightarrow:UIImageView = {
        var rightarrow = UIImageView()
        rightarrow.image = UIImage(named: "arrow")
        rightarrow.contentMode = .scaleAspectFit
        rightarrow.translatesAutoresizingMaskIntoConstraints = false
        return rightarrow
    }()
    
    lazy var nameLabel : UILabel = {
        
        var nameLabel = UILabel()
        nameLabel.text = "Select Service"
        nameLabel.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        nameLabel.numberOfLines = 0
        nameLabel.translatesAutoresizingMaskIntoConstraints = false
        return nameLabel
        
    }()
    
    lazy var selectedLabel : UILabel = {
        var selectedLabel = UILabel()
        selectedLabel.font = UIFont.systemFont(ofSize: 16, weight: .regular)
        selectedLabel.translatesAutoresizingMaskIntoConstraints = false
        return selectedLabel
    }()
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        self.selectionStyle = .none
        self.contentView.addSubview(leftView)
        
        NSLayoutConstraint(item: leftView, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: leftView, attribute: .width, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: 145).isActive = true
        
        
        
        
        self.contentView.addSubview(rightView)
        
        NSLayoutConstraint(item: rightView, attribute: .leading, relatedBy: .equal, toItem: leftView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .top, relatedBy: .equal, toItem: self.contentView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: rightView, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        
        leftView.addSubview(nameLabel)
        
        NSLayoutConstraint(item: nameLabel, attribute: .leading, relatedBy: .equal, toItem: self.leftView, attribute: .leading, multiplier: 1, constant: 15).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .top, relatedBy: .equal, toItem: self.leftView, attribute: .top, multiplier: 1, constant: 15).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .bottom, relatedBy: .equal, toItem: self.leftView, attribute: .bottom, multiplier: 1, constant: -15).isActive = true
        NSLayoutConstraint(item: nameLabel, attribute: .trailing, relatedBy: .equal, toItem: self.leftView, attribute: .trailing, multiplier: 1, constant: -15).isActive = true
        
        
        rightView.addSubview(selectedLabel)
        
        NSLayoutConstraint(item: selectedLabel, attribute: .leading, relatedBy: .equal, toItem: self.rightView, attribute: .leading, multiplier: 1, constant: 15).isActive = true
        NSLayoutConstraint(item: selectedLabel, attribute: .top, relatedBy: .equal, toItem: self.rightView, attribute: .top, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: selectedLabel, attribute: .bottom, relatedBy: .equal, toItem: self.rightView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: selectedLabel, attribute: .trailing, relatedBy: .equal, toItem: self.rightView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        
        rightView.addSubview(rightarrow)
        
        NSLayoutConstraint(item: rightarrow, attribute: .trailing, relatedBy: .equal, toItem: self.rightView, attribute: .trailing, multiplier: 1, constant: -15).isActive = true
        
        self.contentView.addSubview(separator)
        NSLayoutConstraint(item: separator, attribute: .leading, relatedBy: .equal, toItem: self.contentView, attribute: .leading, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .trailing, relatedBy: .equal, toItem: self.contentView, attribute: .trailing, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .bottom, relatedBy: .equal, toItem: self.contentView, attribute: .bottom, multiplier: 1, constant: 0).isActive = true
        NSLayoutConstraint(item: separator, attribute: .height, relatedBy: .equal, toItem: nil, attribute: .notAnAttribute, multiplier: 1, constant: 0.5).isActive = true
        
        
        
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
}
