//
//  shuttleView.swift
//  Zoho Creator SDK Demo
//
//  Created by ZOHO corporation  on 06/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation
import ZCCoreFramework


class ShuttleView: UIView {
    var form : Form?
    var unAlteredForm : Form?
    var fields: [FieldProtocol] = []
    var locationChoices: [Choice] = []
    var timeChoices: [Choice] = []
    
    var selectedLocationChoice: Choice?
    var selectedTimeChoice: Choice?
    
    weak var formViewControllerDelegate: FormViewController?
    
    
    lazy var shuttleCellsParentView : UIView = {
        let shuttleCellsParentView = UIView()
        shuttleCellsParentView.translatesAutoresizingMaskIntoConstraints = false
        shuttleCellsParentView.backgroundColor = UIColor.white
        addSubview(shuttleCellsParentView)
        
        let shuttleCellsParentViewHeight : CGFloat = 144
        let safeAreaView = self
        NSLayoutConstraint.activate([shuttleCellsParentView.leftAnchor.constraint(equalTo: safeAreaView.leftAnchor),shuttleCellsParentView.rightAnchor.constraint(equalTo: safeAreaView.rightAnchor),shuttleCellsParentView.topAnchor.constraint(equalTo: safeAreaView.topAnchor),shuttleCellsParentView.heightAnchor.constraint(equalToConstant: shuttleCellsParentViewHeight)])
        return shuttleCellsParentView
    }()
    
    
    
    lazy var submitButton : UIButton = {
        
        let buttonHeight: CGFloat = 50
        
        
        let submitButton = UIButton()
        submitButton.translatesAutoresizingMaskIntoConstraints = false
        
        submitButton.addTarget(self, action: #selector(submitForm(_:)), for: .touchUpInside)
        submitButton.setTitle("Submit", for: UIControl.State.normal)
        submitButton.setTitleColor(UIColor.init(red: 0/255.0, green: 118/255.0, blue: 255/255.0, alpha: 1/1.0), for: UIControl.State.normal)
        self.addSubview(submitButton)
        
        NSLayoutConstraint.activate([submitButton.leftAnchor.constraint(equalTo: self.leftAnchor),submitButton.rightAnchor.constraint(equalTo: self.rightAnchor),submitButton.topAnchor.constraint(equalTo: shuttleCellsParentView.bottomAnchor, constant: 31.00),submitButton.heightAnchor.constraint(equalToConstant: buttonHeight)])
        
        let submitButtonTopBorderView = UIView()
        submitButtonTopBorderView.translatesAutoresizingMaskIntoConstraints = false
        submitButton.addSubview(submitButtonTopBorderView)
        submitButtonTopBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        let selectDropLocationBorderViewHeight : CGFloat = 1
        
        NSLayoutConstraint.activate([submitButtonTopBorderView.leftAnchor.constraint(equalTo: submitButton.leftAnchor),submitButtonTopBorderView.rightAnchor.constraint(equalTo: submitButton.rightAnchor),submitButtonTopBorderView.topAnchor.constraint(equalTo: submitButton.topAnchor),submitButtonTopBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
        
        let submitButtonBottomBorderView = UIView()
        submitButtonBottomBorderView.translatesAutoresizingMaskIntoConstraints = false
        submitButton.addSubview(submitButtonBottomBorderView)
        submitButtonBottomBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        
        NSLayoutConstraint.activate([submitButtonBottomBorderView.leftAnchor.constraint(equalTo: submitButton.leftAnchor),submitButtonBottomBorderView.rightAnchor.constraint(equalTo: submitButton.rightAnchor),submitButtonBottomBorderView.bottomAnchor.constraint(equalTo: submitButton.bottomAnchor),submitButtonBottomBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
        
        return submitButton
    }()
    
    lazy var selectDropLocationBorderView : UIView = {
        let selectDropLocationBorderView = UIView()
        selectDropLocationBorderView.translatesAutoresizingMaskIntoConstraints = false
        shuttleCellsParentView.addSubview(selectDropLocationBorderView)
        
        let selectDropLocationBorderViewHeight : CGFloat = 1
        
        
        let safeAreaView = self
        NSLayoutConstraint.activate([selectDropLocationBorderView.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor),selectDropLocationBorderView.rightAnchor.constraint(equalTo: shuttleCellsParentView.rightAnchor),selectDropLocationBorderView.topAnchor.constraint(equalTo: selectDropLocationLabelHolder.bottomAnchor),selectDropLocationBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
        return selectDropLocationBorderView
    }()
    
    
    lazy var availabelStatusBorderView : UIView = {
        let selectDropLocationBorderView = UIView()
        selectDropLocationBorderView.translatesAutoresizingMaskIntoConstraints = false
        shuttleCellsParentView.addSubview(selectDropLocationBorderView)
        
        let selectDropLocationBorderViewHeight : CGFloat = 1
        
        let safeAreaView = self
        NSLayoutConstraint.activate([selectDropLocationBorderView.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor),selectDropLocationBorderView.rightAnchor.constraint(equalTo: shuttleCellsParentView.rightAnchor),selectDropLocationBorderView.bottomAnchor.constraint(equalTo: shuttleCellsParentView.bottomAnchor),selectDropLocationBorderView.heightAnchor.constraint(equalToConstant: selectDropLocationBorderViewHeight)])
        return selectDropLocationBorderView
    }()
    
    
    lazy var arrowImageView : UIImageView = {
            let imageView = UIImageView()
            imageView.image = UIImage.init(named: "arrow") ?? nil
            imageView.contentMode = .scaleAspectFit
            imageView.translatesAutoresizingMaskIntoConstraints = false
            shuttleCellsParentView.addSubview(imageView)
            return imageView
    }()
    
    
    lazy var availabelStatusArrowImageView : UIImageView = {
            let imageView = UIImageView()
            imageView.image = UIImage.init(named: "arrow") ?? nil
            imageView.contentMode = .scaleAspectFit
            imageView.translatesAutoresizingMaskIntoConstraints = false
            shuttleCellsParentView.addSubview(imageView)
            
            return imageView
    }()
    
    
    lazy var selectDropLocationLabelHolder : UIView = {
        let selectDropLocationLabelHolder = UIView()
        selectDropLocationLabelHolder.translatesAutoresizingMaskIntoConstraints = false
        selectDropLocationLabelHolder.backgroundColor =  UIColor.init(red: 249/255.0, green: 249/255.0, blue: 249/255.0, alpha: 1/1.0)
        shuttleCellsParentView.addSubview(selectDropLocationLabelHolder)
        
        
        let selectDropLocationLabelHeight : CGFloat = 72
        let selectDropLocationLabelWidth : CGFloat = 145
        
        NSLayoutConstraint.activate([selectDropLocationLabelHolder.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor, constant: 0),selectDropLocationLabelHolder.widthAnchor.constraint(equalToConstant: selectDropLocationLabelWidth),selectDropLocationLabelHolder.topAnchor.constraint(equalTo: shuttleCellsParentView.topAnchor, constant:0),selectDropLocationLabelHolder.heightAnchor.constraint(equalToConstant: selectDropLocationLabelHeight)])
        
        return selectDropLocationLabelHolder
    }()
    
    
    lazy var availableShuttlesLabelHolder : UIView = {
        let availableShuttlesLabelHolder = UIView()
        availableShuttlesLabelHolder.translatesAutoresizingMaskIntoConstraints = false
        
        shuttleCellsParentView.addSubview(availableShuttlesLabelHolder)
        
        
        let selectDropLocationLabelHeight : CGFloat = 72
        let selectDropLocationLabelWidth : CGFloat = 145
        
        NSLayoutConstraint.activate([availableShuttlesLabelHolder.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor, constant: 0),availableShuttlesLabelHolder.widthAnchor.constraint(equalToConstant: selectDropLocationLabelWidth),availableShuttlesLabelHolder.topAnchor.constraint(equalTo: selectDropLocationLabelHolder.bottomAnchor, constant:0),availableShuttlesLabelHolder.heightAnchor.constraint(equalToConstant: selectDropLocationLabelHeight)])
        
        return availableShuttlesLabelHolder
    }()
    
    
    
    
    lazy var selectedLocation : UILabel = {
        let selectedLocation = UILabel()
        selectedLocation.translatesAutoresizingMaskIntoConstraints = false
        selectedLocation.font = UIFont.systemFont(ofSize: 16)
        selectedLocation.numberOfLines = 0
        selectedLocation.isUserInteractionEnabled = true
        selectedLocation.textColor = UIColor.init(red: 163.0/255.0, green: 163.0/255.0, blue: 163.0/255.0, alpha: 1/1.0)
        selectedLocation.text = "New Casimer"
        shuttleCellsParentView.addSubview(selectedLocation)
        let selectedLocationiewHeight : CGFloat = 72
        
        NSLayoutConstraint.activate([selectedLocation.leftAnchor.constraint(equalTo: selectDropLocationLabelHolder.rightAnchor, constant: 15),selectedLocation.rightAnchor.constraint(equalTo: shuttleCellsParentView.rightAnchor),selectedLocation.topAnchor.constraint(equalTo: shuttleCellsParentView.topAnchor),selectedLocation.heightAnchor.constraint(equalToConstant: selectedLocationiewHeight)])
        
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(self.availabelLocations))
        selectedLocation.addGestureRecognizer(tapGesture)
        
        return selectedLocation
    }()
    
    
    
    lazy var selectedTime : UILabel = {
        let selectedTime = UILabel()
        selectedTime.translatesAutoresizingMaskIntoConstraints = false
        selectedTime.font = UIFont.systemFont(ofSize: 16)
        selectedTime.numberOfLines = 0
        selectedTime.isUserInteractionEnabled = true
        selectedTime.textColor = UIColor.init(red: 163.0/255.0, green: 163.0/255.0, blue: 163.0/255.0, alpha: 1/1.0)
        selectedTime.text = "07:30 PM"
        shuttleCellsParentView.addSubview(selectedTime)
        let selectedLocationiewHeight : CGFloat = 72
        
        NSLayoutConstraint.activate([selectedTime.leftAnchor.constraint(equalTo: selectDropLocationLabelHolder.rightAnchor, constant: 15),selectedTime.rightAnchor.constraint(equalTo: shuttleCellsParentView.rightAnchor),selectedTime.topAnchor.constraint(equalTo: availableShuttlesLabelHolder.topAnchor),selectedTime.heightAnchor.constraint(equalToConstant: selectedLocationiewHeight)])
        
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(self.availabelTimes))
        selectedTime.addGestureRecognizer(tapGesture)
        
        return selectedTime
    }()
    
    init(form : Form?) {
        super.init(frame: .zero)
        
        if let form = form {
            self.form = form
            unAlteredForm = form
            filterFields()
            configureView()
        }
        
    }
    
    
    func filterFields() {
        self.fields = []
        let fields : [FieldProtocol] = (form?.fields)!
        for  field in fields {
            if(field.fieldType == FieldType.dropdown) {
                self.fields.append(field)
            }
        }
        parseLocationAndTimeChoices()
    }
    
    
    func  parseLocationAndTimeChoices ()  {
        locationChoices = []
        timeChoices = []
        for field in self.fields {
            if(field.linkName == "Select_Drop_Location"){
                let field = field as! DropdownField
                let fieldValue:SingleSelectChoiceFieldValue  = field.fieldValue
                let choices: [Choice] = fieldValue.choices
                locationChoices.append(contentsOf: choices)
            } else if(field.linkName == "Available_shuttles"){
                let field = field as! DropdownField
                let fieldValue:SingleSelectChoiceFieldValue  = field.fieldValue
                let choices: [Choice] = fieldValue.choices
                timeChoices.append(contentsOf: choices)
            }
        }
    }
    
    @objc func availabelLocations() {
        let lister =  TimeAndLocationsChoicesLister()
        lister.parentView = self
        lister.listerType = .location
        lister.selectedChoice = selectedLocationChoice
        lister.choiceList = locationChoices
        let navigationController = UINavigationController(rootViewController: lister)
        if let navigController = formViewControllerDelegate?.navigationController {
            navigController.pushViewController(lister, animated: true)
        } else {
            formViewControllerDelegate?.present(navigationController, animated: true, completion: nil)
        }
    }
    
    
    func selectedChoice(choice: Choice, type: ListerType)  {
        if(type == .location){
            if(selectedLocationChoice?.key == choice.key){
                selectedLocationChoice = nil
                updateSelectedChoiceValue(location: "Tap to Select")
                 selectedLocation.textColor = UIColor.init(red: 163.0/255.0, green: 163.0/255.0, blue: 163.0/255.0, alpha: 1/1.0)
                updateModal(choice: choice, type: type, isAdded : false)
            }else {
                selectedLocationChoice = choice
                selectedLocation.textColor = UIColor.black
                updateSelectedChoiceValue(location: choice.key)
                updateModal(choice: choice, type: type, isAdded : true)
            }
            
        } else if (type == .time){
            if(selectedTimeChoice?.key == choice.key){
                selectedTimeChoice = nil
                updateSelectedTimeValue(time: "Tap to Select")
                selectedTime.textColor = UIColor.init(red: 163.0/255.0, green: 163.0/255.0, blue: 163.0/255.0, alpha: 1/1.0)
                updateModal(choice: choice, type: type, isAdded : false)
            }else {
                selectedTimeChoice = choice
                updateSelectedTimeValue(time: choice.key)
                selectedTime.textColor = UIColor.black
                updateModal(choice: choice, type: type, isAdded : true)
            }
            
            
        }
    }
    
    
    func updateModal(choice: Choice, type: ListerType, isAdded: Bool) {
        for field in self.fields {
            if(type == .location && (field.linkName == "Select_Drop_Location")){
                var field = field as! DropdownField
                var fieldValue:SingleSelectChoiceFieldValue  = field.fieldValue
                if(isAdded){
                    fieldValue.selectedChoice = choice
                }else{
                    fieldValue.selectedChoice = nil
                }
                field.fieldValue = fieldValue
                fields.remove(at: 0)
                fields.insert(field, at: 0)
                break
            } else if(type == .time && (field.linkName == "Available_shuttles")){
                var field = field as! DropdownField
                var fieldValue:SingleSelectChoiceFieldValue  = field.fieldValue
                if(isAdded){
                    fieldValue.selectedChoice = choice
                }else{
                    fieldValue.selectedChoice = nil
                }
                field.fieldValue = fieldValue
                fields.remove(at: 1)
                fields.insert(field, at: 1)
                break
            }
        }
    }
    
    
    @objc func availabelTimes() {
        let lister =  TimeAndLocationsChoicesLister()
        lister.parentView = self
        lister.listerType = .time
        lister.selectedChoice = selectedTimeChoice
        lister.choiceList = timeChoices
        let navigationController = UINavigationController(rootViewController: lister)
        if let navigController = formViewControllerDelegate?.navigationController {
            navigController.pushViewController(lister, animated: true)
        } else {
            formViewControllerDelegate?.present(navigationController, animated: true, completion: nil)
        }
        
    }
    
    func  refreshForm()  {
        self.form = self.unAlteredForm
        var selectedTime = ""
        if let selectedTimeChoice = selectedTimeChoice {
           selectedTime = selectedTimeChoice.key
        }
        
        formViewControllerDelegate!.showSuccessCabBookingView(selectedTime: selectedTime)
        selectedLocationChoice = nil
        selectedTimeChoice = nil
    }
    
    
    @objc func submitForm(_ sender: UIButton) {
        formViewControllerDelegate?.showActionLoading(show: true)
        updateSelectedChoices()
        if let form = form {
            ZohoCreatorAPIHandler.submit(form: form) { (result) in
                self.refreshForm()
                self.formViewControllerDelegate?.showActionLoading(show: false)
                switch result {
                case .failure( let error):
                    self.formViewControllerDelegate?.showMessage(message: error.localizedDescription)
                case .success(let value):do {
                    print (value)
                    }
                }
            }
        }
    }
    
    
    func updateSelectedChoices() {
        let originalFields : [FieldProtocol] = (form?.fields)!
        for  originalField in originalFields {
            for filteredField in self.fields {
                if(originalField.linkName == filteredField.linkName) {
                    if let index = form?.getIndex(linkName: filteredField.linkName) {
                        self.form?.setField(filteredField, at: index)
                    }
                }
            }
        }
    }
    
    func configureView() {
       
        backgroundColor = UIColor.init(red: 239/255.0, green: 239/255.0, blue: 244/255.0, alpha: 1/1.0)
        self.translatesAutoresizingMaskIntoConstraints = false
       
        
        let selectDropLocationLabelHeight : CGFloat = 72
        let selectDropLocationLabelWidth : CGFloat = 115
        
        selectDropLocationLabelHolder.backgroundColor =  UIColor.init(red: 249/255.0, green: 249/255.0, blue: 249/255.0, alpha: 1/1.0)
        
        availableShuttlesLabelHolder.backgroundColor =  UIColor.init(red: 249/255.0, green: 249/255.0, blue: 249/255.0, alpha: 1/1.0)
        
        
        let selectDropLocationLabel = UILabel()
        selectDropLocationLabel.translatesAutoresizingMaskIntoConstraints = false
        selectDropLocationLabel.font = UIFont.systemFont(ofSize: 16)
        selectDropLocationLabel.numberOfLines = 0
        
        selectDropLocationLabel.textColor = UIColor.black
        let dropLocationTitle = self.fields[0].displayName
        selectDropLocationLabel.text = dropLocationTitle
        shuttleCellsParentView.addSubview(selectDropLocationLabel)
        
        NSLayoutConstraint.activate([selectDropLocationLabel.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor, constant: 15),selectDropLocationLabel.widthAnchor.constraint(equalToConstant: selectDropLocationLabelWidth),selectDropLocationLabel.topAnchor.constraint(equalTo: shuttleCellsParentView.topAnchor, constant:0),selectDropLocationLabel.heightAnchor.constraint(equalToConstant: selectDropLocationLabelHeight)])
        
        
        let availableShuttlesLabel = UILabel()
        availableShuttlesLabel.translatesAutoresizingMaskIntoConstraints = false
        availableShuttlesLabel.font = UIFont.systemFont(ofSize: 16)
        availableShuttlesLabel.numberOfLines = 0
        
        availableShuttlesLabel.textColor = UIColor.black
        let availableShuttlesTitle = self.fields[1].displayName
        availableShuttlesLabel.text = availableShuttlesTitle
        shuttleCellsParentView.addSubview(availableShuttlesLabel)
        
        NSLayoutConstraint.activate([availableShuttlesLabel.leftAnchor.constraint(equalTo: shuttleCellsParentView.leftAnchor, constant: 15),availableShuttlesLabel.widthAnchor.constraint(equalToConstant: selectDropLocationLabelWidth),availableShuttlesLabel.topAnchor.constraint(equalTo: availableShuttlesLabelHolder.topAnchor, constant:0),availableShuttlesLabel.heightAnchor.constraint(equalToConstant: selectDropLocationLabelHeight)])
        
        updateSelectedChoiceValue(location: "Tap to Select")
        updateSelectedTimeValue(time: "Tap to Select")
        
        let xOrigin:CGFloat = UIScreen.main.bounds.size.width/2 - (arrowImageView.image?.size.width)!
        NSLayoutConstraint.activate([
            arrowImageView.centerXAnchor.constraint(equalTo: shuttleCellsParentView.centerXAnchor, constant: xOrigin),
            arrowImageView.centerYAnchor.constraint(equalTo: selectedLocation.centerYAnchor),
            ])
        
        let xOriginAvailabelStatus:CGFloat = UIScreen.main.bounds.size.width/2 - (availabelStatusArrowImageView.image?.size.width)!
        NSLayoutConstraint.activate([
            availabelStatusArrowImageView.centerXAnchor.constraint(equalTo: shuttleCellsParentView.centerXAnchor, constant: xOriginAvailabelStatus),
            availabelStatusArrowImageView.centerYAnchor.constraint(equalTo: selectedTime.centerYAnchor),
            ])
        
        selectDropLocationBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        
        availabelStatusBorderView.backgroundColor = UIColor.init(red: 240/255.0, green: 240/255.0, blue: 240/255.0, alpha: 1/1.0)
        
        submitButton.backgroundColor = UIColor.white
    }
    
    
    func updateSelectedTimeValue(time : String) {
        selectedTime.text = time
    }
    
    func updateSelectedChoiceValue(location : String) {
        selectedLocation.text = location
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
