//
//  SuccessfulBookingShuttleView.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 08/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation

class SuccessfulBookingShuttleView: UIView {
    
    lazy var cabIconImageView : UIImageView = {
            let imageView = UIImageView()
            imageView.image = UIImage.init(named: "shuttleLarge") ?? nil
            imageView.translatesAutoresizingMaskIntoConstraints = false
            addSubview(imageView)
            return imageView
    }()
    
    lazy var successBookingMessage : UILabel = {
            let titleLable = UILabel()
            titleLable.translatesAutoresizingMaskIntoConstraints = false
            titleLable.textAlignment = .center
            addSubview(titleLable)
            
            titleLable.font = UIFont.systemFont(ofSize: 16, weight: UIFont.Weight.semibold)
            titleLable.textColor  = UIColor.init(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 1/1.0)
            
            let titleLableWidth : CGFloat = self.frame.size.width
            let titleLableHeight : CGFloat = 22
            
            NSLayoutConstraint.activate([titleLable.leftAnchor.constraint(equalTo: self.leftAnchor, constant: 0),titleLable.rightAnchor.constraint(equalTo: self.rightAnchor),titleLable.topAnchor.constraint(equalTo: cabIconImageView.bottomAnchor, constant: 30),titleLable.heightAnchor.constraint(equalToConstant: titleLableHeight)])
            
            return titleLable
    }()
    
    lazy var cabTimingMessage : UILabel = {
            let titleLable = UILabel()
            titleLable.translatesAutoresizingMaskIntoConstraints = false
            titleLable.textAlignment = .center
            addSubview(titleLable)
            
            
            titleLable.font = UIFont.systemFont(ofSize: 14, weight: UIFont.Weight.semibold)
            titleLable.textColor  = UIColor.init(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 1/1.0)
            
            let titleLableWidth : CGFloat = self.frame.size.width
            let titleLableHeight : CGFloat = 22
          
            NSLayoutConstraint.activate([titleLable.leftAnchor.constraint(equalTo: successBookingMessage.leftAnchor, constant: 0),titleLable.rightAnchor.constraint(equalTo: self.rightAnchor),titleLable.topAnchor.constraint(equalTo: successBookingMessage.bottomAnchor, constant: 30),titleLable.heightAnchor.constraint(equalToConstant: titleLableHeight)])
            
            return titleLable
    }()
    
    
    weak var formViewControllerDelegate: FormViewController?
    
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        configureView()
    }
    
    func makeChangesForComplain()  {
        cabIconImageView.image =  UIImage.init(named: "complainLarge") ?? nil
        successBookingMessage.text = "Our service superviser will contact you shortly"
    }
    
    func configureView() {
        
        let cabIconVerticalPadding : CGFloat =  -50
        NSLayoutConstraint.activate([
            cabIconImageView.centerXAnchor.constraint(equalTo: centerXAnchor),
            cabIconImageView.centerYAnchor.constraint(equalTo: centerYAnchor,constant: cabIconVerticalPadding)
            ])
        successBookingMessage.text = "Your Cab has been booked successfully"
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}

