//
//  SuppliesFormLocationInputFlowLayout.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 11/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import Foundation

class SuppliesFormLocationInputFlowLayout: UICollectionViewFlowLayout {
    
    let cellSpacing:CGFloat = 10.0
    
    override func layoutAttributesForElements(in rect: CGRect) -> [UICollectionViewLayoutAttributes]? {
        if let attributes = super.layoutAttributesForElements(in: rect) {
            for (index, attribute) in attributes.enumerated() {
                if index == 0 { continue }
                let prevLayoutAttributes = attributes[index - 1]
                
                let origin = prevLayoutAttributes.frame.maxX
                if(origin + cellSpacing + attribute.frame.size.width < self.collectionViewContentSize.width) {
                    attribute.frame.origin.x = origin + cellSpacing
                }
            }
            return attributes
        }
        return nil
    }
}

