//
//  ZohoCreatorAPIHandler.swift
//  ZohoCreatorSDKDemo
//
//  Created by ZOHO corporation  on 08/02/19.
//  Copyright © 2019 ZOHO corporation . All rights reserved.
//

import UIKit
import ZCCoreFramework

class ZohoCreatorAPIHandler: NSObject {
    
    // Fetches All My Apps
    
     public static func fetchMyAppList(completionHandler: @escaping (Result<AppList>) -> Void, shouldCacheResponse: Bool)
    {
        ZCAPIService.fetchAppList(completionHandler: completionHandler)
    }
    
     // Fetches Sections of my app
    
    public static func fetchMySectionList(for application: Application, completionHandler: @escaping (Result<SectionList>) -> Void, shouldCacheResponse: Bool)
    {
        ZCAPIService.fetchSectionList(for: application, completionHandler: completionHandler)
    }
    
    // Fetch User Info From Cache
    public static func fetchMyUserInfoFromCache() -> UserInfo?
    {
        return ZCCacheService.fetchUserInfoFromCache()
        
    }
    
    // Fetch User Info From Server
    public static func fetchMyUserInfo(shouldCacheResponse: Bool, completionHandler: @escaping (Result<UserInfo>) -> Void)
    {
        ZCAPIService.fetchUserInfo(shouldCacheResponse: shouldCacheResponse, completionHandler: completionHandler)
    }
    
    // Submit the Form
    
    public static func submit(form: Form, completionHandler: @escaping (Result<SubmitResponse>) -> Void)
    {
        ZCFormAPIService.submit(form: form, completionHandler: completionHandler)
    }
    
    // Fetch The Form
    public static func fetch(for formInfo: FormInfo, completionHandler: @escaping (Result<WorkFlowChangeSet>) -> Void)
    {
        ZCFormAPIService.fetch(for: formInfo, completionHandler: completionHandler)
    }

}
